
#ifndef __INTERPROTO_H__
#define __INTERPROTO_H__

/* Timeout per l'invio di un messaggio (da specifiche progetto) */
#define INACTIVITY_TIMEOUT_SECONDS 60

/* Message type */
#define CCSWRONG -1
#define CCSCONN   0
#define CCSACCPT  1
#define CCSDATA   2
#define CCSACK    3
#define CCSRST    4
#define CCSRSTACK 5
#define CCSPING 6

/* Message exchanged between client and server */

struct ccs_msg {
	int type;	/* message type */
	int pubfd;	/* public fd */
	int rem_pubfd;	/* remote public fd */
	int bodysize;   /* size of body */
	void *body;	/* message body */
};

struct ccs_msg* ccs_msg_get(int fd);
int ccs_msg_put(int fd, int type, int pubfd, int rem_pubfd, size_t size, void* buf);
void ccs_msg_del(struct ccs_msg *message);

#endif /* interproto.h */

