#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include "main_mgr_proto.h"

#include "utils.h"

int mcm_putrequest(int sp, int type, int* flag, struct sockaddr* addr, int backlog, void* buf, size_t bufsize){
struct mcm_msg_req* msg = NULL;

	msg = (struct mcm_msg_req*)malloc(sizeof(struct mcm_msg_req));
	if( ! msg ){
		perror("mcm_putrequest, malloc");
		exit(-1);
	}
	msg->type = type;
	msg->flag = flag;
	msg->addr = addr;
	msg->backlog = backlog;
	msg->buf = buf;
	msg->bufsize = bufsize;

	if( (write( sp, &msg, sizeof(struct mcm_msg_req*) ))
			!= sizeof(struct mcm_msg_req*) ){
		dbg_printf("mcm_putrequest, write");
		return -1;
	}
	return 0;
}

struct mcm_msg_req* mcm_getreq(int sp){
struct mcm_msg_req* msg = NULL;
int ris = 0;

	ris=read( sp, &msg, sizeof(struct mcm_msg_req*) );
	if( ris == 0 && errno == 0 ){
		return NULL;
	}
	if( ris != sizeof(struct mcm_msg_req*) ){
		perror("mcm_getreq, read");
		exit(-1);
	}
	return msg;
}

void mcm_putreply(int sp, int type, int retval, int myerrno){
struct mcm_msg_reply* msg = NULL;

	msg = (struct mcm_msg_reply*)malloc(sizeof(struct mcm_msg_reply));
	if( ! msg ){
		perror("mcm_putreply, malloc");
		exit(-1);
	}
	/* only for test: printf("msg addr: %d\n", (int)msg); */
	msg->type = type;
	msg->retval = retval;
	msg->myerrno = myerrno;

	if( (write( sp, &msg, sizeof(struct mcm_msg_reply*) ))
			!= sizeof(struct mcm_msg_reply*) ){
		perror("mcm_putreply, write");
		exit(-1);
	}
}

struct mcm_msg_reply* mcm_getreply(int sp){
struct mcm_msg_reply* msg = NULL;

	if( (read( sp, &msg, sizeof(struct mcm_msg_reply*) ))
			!= sizeof(struct mcm_msg_reply*) ){
		perror("mcm_getreply, read");
		exit(-1);
	}
	return msg;
}
