
#ifndef __MAIN_MGR_PROTO_H__
#define __MAIN_MGR_PROTO_H__

/* Message type */
#define SOCKT   0
#define STRADR  1
#define GTRADR	2
#define BIND	3
#define LISTEN	4
#define ACCEPT	5
#define CONNECT	6
#define READ	7
#define WRITE	8
#define CLOSE	9
#define CLOSECCS 10


struct mcm_msg_req {
	int type;
	int* flag;
	struct sockaddr* addr;
	int backlog;
	void* buf;
	size_t bufsize;
};

/* perform request (used by main) */
int mcm_putrequest(int sp, int type, int* flag,
		struct sockaddr* addr, int backlog, void* buf, size_t bufsize);
/*
 * CALLS:
 * sp_mn, SOCKT,   NULL, NULL, -1,      NULL, 0
 * ccsfd, STRADR,  NULL, NULL, -1,      NULL, 0
 * ccsfd, GTRADR,  flag, NULL, -1,      NULL, 0
 * ccsfd, BIND,    NULL, addr, -1,      NULL, 0
 * ccsfd, LISTEN,  NULL, NULL, backlog, NULL, 0
 * ccsfd, ACCEPT,  NULL, addr, -1,      NULL, 0
 * ccsfd, CONNECT, NULL, addr, -1,      NULL, 0
 * ccsfd, READ,    NULL, NULL, -1,      buf,  bufsize
 * ccsfd, WRITE,   NULL, NULL, -1,      buf,  bufsize
 * ccsfd, CLOSE,   NULL, NULL, -1,      NULL, 0
 * sp_mn, CLOSECCS,NULL, NULL, -1,      NULL, 0
 */

/* get request (used by ccs manager) */
struct mcm_msg_req* mcm_getreq(int sp);


struct mcm_msg_reply {
	int type;
	int retval;
	int myerrno;
};

/* perform reply (used by ccs_manager) */
void mcm_putreply(int sp, int type, int retval, int myerrno);
/*
 * CALLS:
 * sp, NACK,	-1,		-1
 * sp, SOCKT,	int ccsfd,	-1
 * sp, STRADR,	int retval,	int errno
 * sp, GTRADR,	-1		-1
 * sp, BIND,	int retval,	int errno
 * sp, LISTEN,	int retval,	int errno
 * sp, ACCEPT,	int retval,	int errno
 * sp, CONNECT,	int retval,	int errno
 * sp, READ,	size_t retval,	int errno
 * sp, WRITE,	size_t retval,	int errno
 * sp, CLOSE,	int retval,	int errno
 */

/* get reply (used by main) */
struct mcm_msg_reply* mcm_getreply(int sp);


#endif /* main_mgr_proto.h */

